crashpad::MinidumpExceptionWriter Class Referencefinal

The writer for a MINIDUMP_EXCEPTION_STREAM stream in a minidump file. More...

`#include "minidump/minidump_exception_writer.h"`

Inheritance diagram for crashpad::MinidumpExceptionWriter:

## Public Member Functions

void | InitializeFromSnapshot (const ExceptionSnapshot *exception_snapshot, const MinidumpThreadIDMap &thread_id_map)
| Initializes the MINIDUMP_EXCEPTION_STREAM based on exception_snapshot. More...
void | SetContext (std::unique_ptr< MinidumpContextWriter > context)
| Arranges for MINIDUMP_EXCEPTION_STREAM::ThreadContext to point to the CPU context to be written by context. More...
void | SetThreadID (uint32_t thread_id)
| Sets MINIDUMP_EXCEPTION_STREAM::ThreadId.
void | SetExceptionCode (uint32_t exception_code)
| Sets MINIDUMP_EXCEPTION::ExceptionCode.
void | SetExceptionFlags (uint32_t exception_flags)
| Sets MINIDUMP_EXCEPTION::ExceptionFlags.
void | SetExceptionRecord (uint64_t exception_record)
| Sets MINIDUMP_EXCEPTION::ExceptionRecord.
void | SetExceptionAddress (uint64_t exception_address)
| Sets MINIDUMP_EXCEPTION::ExceptionAddress.
void | SetExceptionInformation (const std::vector< uint64_t > &exception_information)
| Sets MINIDUMP_EXCEPTION::ExceptionInformation and MINIDUMP_EXCEPTION::NumberParameters. More...
Public Member Functions inherited from crashpad::internal::MinidumpStreamWriter
const MINIDUMP_DIRECTORY * | DirectoryListEntry () const
| Returns a MINIDUMP_DIRECTORY entry that serves as a pointer to this stream. More...
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Protected Member Functions

bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
std::vector< MinidumpWritable * > | Children () override
| Returns the object’s children. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
MinidumpStreamType | StreamType () const override
| Returns an object’s stream type. More...
Protected Member Functions inherited from crashpad::internal::MinidumpStreamWriter
bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members

Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static constexpr size_t | kInvalidSize = std::numeric_limits<size_t>::max()
| A size value used to signal failure by methods that return `size_t`.

## Detailed Description

The writer for a MINIDUMP_EXCEPTION_STREAM stream in a minidump file.

## Member Function Documentation

## Children()

std::vector< internal::MinidumpWritable * > crashpad::MinidumpExceptionWriter::Children | ( |  | ) |

overrideprotectedvirtual

Returns the object’s children.

Note
  Valid in kStateFrozen or any subsequent state.

Reimplemented from crashpad::internal::MinidumpWritable.

## Freeze()

bool crashpad::MinidumpExceptionWriter::Freeze | ( |  | ) |

overrideprotectedvirtual

Transitions the object from kStateMutable to kStateFrozen.

The default implementation marks the object as frozen and recursively calls Freeze() on all of its children. Subclasses may override this method to perform processing that should only be done once callers have finished populating an object with data. Typically, a subclass implementation would call RegisterRVA() or RegisterLocationDescriptor() on other objects as appropriate, because at the time Freeze() runs, the in-memory locations of RVAs and location descriptors are known and will not change for the remaining duration of an object’s lifetime.

Returns
  `true` on success. `false` on failure, with an appropriate message logged.

Reimplemented from crashpad::internal::MinidumpWritable.

## InitializeFromSnapshot()

void crashpad::MinidumpExceptionWriter::InitializeFromSnapshot | ( | const ExceptionSnapshot * | exception_snapshot,
|  | const MinidumpThreadIDMap & | thread_id_map
| ) |  |

Initializes the MINIDUMP_EXCEPTION_STREAM based on exception_snapshot.

Parameters

  [in] | exception_snapshot | The exception snapshot to use as source data.
  [in] | thread_id_map | A MinidumpThreadIDMap to be consulted to determine the 32-bit minidump thread ID to use for the thread identified by exception_snapshot.

Note
  Valid in kStateMutable. No mutator methods may be called before this method, and it is not normally necessary to call any mutator methods after this method.

## SetContext()

void crashpad::MinidumpExceptionWriter::SetContext | ( | std::unique_ptr< MinidumpContextWriter > | context | ) |

Arranges for MINIDUMP_EXCEPTION_STREAM::ThreadContext to point to the CPU context to be written by context.

A context is required in all MINIDUMP_EXCEPTION_STREAM objects.

This object takes ownership of context and becomes its parent in the overall tree of internal::MinidumpWritable objects.

Note
  Valid in kStateMutable.

## SetExceptionInformation()

void crashpad::MinidumpExceptionWriter::SetExceptionInformation | ( | const std::vector< uint64_t > & | exception_information | ) |

Sets MINIDUMP_EXCEPTION::ExceptionInformation and MINIDUMP_EXCEPTION::NumberParameters.

MINIDUMP_EXCEPTION::NumberParameters is set to the number of elements in exception_information. The elements of MINIDUMP_EXCEPTION::ExceptionInformation are set to the elements of exception_information. Unused elements in MINIDUMP_EXCEPTION::ExceptionInformation are set to `0`.

exception_information must have no more than EXCEPTION_MAXIMUM_PARAMETERS elements.

Note
  Valid in kStateMutable.

## SizeOfObject()

size_t crashpad::MinidumpExceptionWriter::SizeOfObject | ( |  | ) |

overrideprotectedvirtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## StreamType()

MinidumpStreamType crashpad::MinidumpExceptionWriter::StreamType | ( |  | ) | const

overrideprotectedvirtual

Returns an object’s stream type.

Note
  Valid in any state.

Implements crashpad::internal::MinidumpStreamWriter.

## WriteObject()

bool crashpad::MinidumpExceptionWriter::WriteObject | ( | FileWriterInterface * | file_writer | ) |

overrideprotectedvirtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_exception_writer.h
- minidump/minidump_exception_writer.cc